var g_baseDir = "d:\\acbot\\";

var g_routes = new Array(
"lif-to-store.route",
"store-to-door1.route",
"door1-to-door2.route",
"door2-to-door3.route",
"door2-to-black.route",
"black-to-door3.route",
"door3-to-merch.route",
"lif-to-mage.route"
);

function delayTime(time) {
	skapi.WaitEvent(time,wemFullTimeout);	
}

var g_doorOpen = false;
var g_itemBought = 0;
var g_noteAco = null;
var g_globalTimer;
var route = new Route();
var g_restart = false;

function doorOpenHandler() {
	this.OnChatServer = doorOpenChatServer;
	this.OnAddToInventory = itemAddToInv;
	this.OnApproachVendor = approachVendor;
//	this.OnLocChangeSelf = OnLocChangeSelf;
}

function doorOpenChatServer(szmsg,cmc) {
	if (szmsg.match(/open/)) g_doorOpen = true;
}

function itemAddToInv(aco) {
	if (aco.szName == "Training Cestus" &&
		aco.acoContainer == skapi.AcoFromIpackIitem(0,-1)) {
		g_itemBought++;
	}
}

function OnLocChangeSelf(maploc) {
/*    if (g_globalTimer.cmsec > 13*60*1000) {
        route.StopRoute();
		g_restart = true;
    }*/
}

function approachVendor(acoMerchant, mcmBuy, cpyMaxBuy, fractBuy, fractSell, coaco) {
	g_noteAco = null;
	for (var i=0; i<coaco.count; i++) {
		var aco = coaco.Item(i);
		if (aco.szName == "Trade Note" &&
			aco.cpyValue == 100000) {
			g_noteAco = aco;
			return;
		}
	}
}

function moveCestusToPack() {
	delayTime(100);
	var mainpack = skapi.AcoFromIpackIitem(0,-1);
	var mainpackCo = mainpack.coacoContents;
	for (var j=0; j<mainpackCo.Count; j++) {
		var aco = mainpackCo.Item(j);
		if (aco.szName != "Training Cestus") continue;
		for (var k=1; k<8; k++) {
			var pack = skapi.AcoFromIpackIitem(k,-1);
			if (pack.citemContents < pack.citemMax) {
				aco.MoveToPack(k,0,false);
				skapi.WaitEvent(5000,wemSpecific,evidOnMoveItem);
				return true;
			}
		}	
	}
	return false;
}

function openDoor(door) {
	skapi.SelectAco(door);
	g_doorOpen = false;
	delayTime(1000);
	skapi.AddHandler(evidOnChatServer,g_doorOpenHandler);
	for (var i=0; i<15; i++) {
		skapi.Keys(cmidUseSelected);
		delayTime(500);
		if (g_doorOpen) break;
	}
	skapi.RemoveHandler(evidOnChatServer,g_doorOpenHandler);
}

function getDoor() {
	var doorCol = skapi.CoacoFromOcm(ocmAll);
	var closest = 10000;
	var numc = -1;
	for (var i=0; i<doorCol.count; i++) {
		var aco = doorCol.Item(i);
		if (aco.szName == "Academy Practice Area Door") {
			var dist = Dist3DToMaploc(aco.maploc);
			if (dist < closest) {
				closest = dist;
				numc = i;
			}
		}
	}
	if (numc == -1) return null;
	return doorCol.Item(numc);
}

var g_doorOpenHandler = new doorOpenHandler();

function main() {
	var startCash = skapi.cpyCash;
	var totalMoneyMade = 0;

//	skapi.AddHandler(evidOnLocChangeSelf,g_doorOpenHandler);

	for (;;) {
	try {
	var startTime = new Date();
	delayTime(50);
	var curCash = skapi.cpyCash;

	// Reset the timeout timer
	g_restart = false;
	g_globalTimer = skapi.TimerNew();

	skapi.Keys("{return}");
	skapi.PasteSz("/lifestone");
	skapi.Keys("{return}");
	delayTime(15000);

	route.FromFile(g_baseDir + g_routes[0]);
	if (route.Go(60)==1) continue;
	//if (g_restart == true) continue;

	delayTime(50);
	var merch = skapi.AcoFromSz("Nen Gou the Shopkeeper");

	for (var i=1; i<8; i++) {
		delayTime(150);
		var pack = skapi.AcoFromIpackIitem(i,-1);
		if (pack.citemContents != 0) {
			// sell the pack
			skapi.SelectAco(merch);
			delayTime(150);
			skapi.SelectAco(pack);
			delayTime(150);
			skapi.Keys("u");	// Give item
			if (i==1) delayTime(3000);
			else delayTime(350);
		}
	}

	delayTime(1000);
	skapi.Keys(cmidAllegiancePanel);
	delayTime(1000);

	// Sell the items
	skapi.MouseMove(686,640);
	skapi.MouseButton(ibuttonLeft);
	skapi.waitevent(6000,wemSpecific,evidOnAddToInventory);

	// Check if we need to buy M note
	delayTime(100);
	if (skapi.cpyCash > 350000) {
		route.FromFile(g_baseDir + g_routes[7]);
		if (route.Go(10*60)==1) continue;
		//if (g_restart == true) continue;
		
		skapi.AddHandler(evidOnApproachVendor,g_doorOpenHandler);

		// Select the shopkeeper
		var merch = skapi.AcoFromSz("Archmage Chen Wah-Ji");
		skapi.SelectAco(merch);
		delayTime(150);
		skapi.Keys(cmidUseSelected);
		skapi.WaitEvent(20000,wemSpecific,evidOnApproachVendor);

		skapi.RemoveHandler(evidOnApproachVendor,g_doorOpenHandler);

		// Select the trade note category
		skapi.MouseMove(60,599);
		delayTime(250);
		skapi.MouseButton(ibuttonLeft);
		delayTime(2000);
		skapi.MouseMove(60,688);
		delayTime(250);
		skapi.MouseButton(ibuttonLeft);
		delayTime(2000);

		// Select the trade note
		skapi.SelectAco(g_noteAco);
		delayTime(250);

		// Move to add to list
		skapi.MouseMove(686,640);
		delayTime(250);

		var numToBuy = Math.floor(skapi.cpyCash / 115000);
		skapi.OutputLine("Buying: "+numToBuy+" trade notes.");
		for (var j=0; j<numToBuy; j++) {
			// Add to list
			skapi.MouseButton(ibuttonLeft);
			delayTime(50);
		}
		totalMoneyMade += numToBuy * 110000;

		// Move to buy list
		skapi.MouseMove(137,576);
		skapi.MouseButton(ibuttonLeft);
		delayTime(250);

		// Buy all
		skapi.MouseMove(686,640);
		skapi.MouseButton(ibuttonLeft);
		
		delayTime(10000);

		skapi.Keys("{return}");
		skapi.PasteSz("/lifestone");
		skapi.Keys("{return}");
		delayTime(15000);
	}

	// Run to portal
	route.FromFile(g_baseDir + g_routes[1]);
	if (route.Go(120)==1) continue;
	//if (g_restart == true) continue;

	// Check if we need a new key
	var key = skapi.AcoFromSz("Greeter's Key");
	delayTime(100);
	if (key == null) {
		// Get a new key
		var chest = skapi.AcoFromSz("Greeter's Chest");
		skapi.SelectAco(chest);
		delayTime(1000);

		skapi.Keys(cmidUseSelected);
		delayTime(8000);

		var chestCo = chest.coacoContents;
		for (var j=0; j<chestCo.Count; j++) {
			var aco = chestCo.Item(j);
			if (aco.szName == "Application Form") {
				delayTime(100);
				skapi.SelectAco(aco);
				delayTime(100);

				skapi.Keys(cmidUseSelected);
				delayTime(10000);
			}
		}

		var mainpack = skapi.AcoFromIpackIitem(0,-1);
		var mainpackCo = mainpack.coacoContents;
		for (var j=0; j<mainpackCo.Count; j++) {
			var aco = mainpackCo.Item(j);
			if (aco.szName == "Application Form") {
				var greeter = skapi.AcoFromSz("Greeter");
				skapi.SelectAco(greeter);
				delayTime(150);
				skapi.SelectAco(aco);
				delayTime(150);
				skapi.Keys("u");	// Give item
				delayTime(5000);
			}
		}
	}

	var tries = 0;
	g_doorOpen = false;
	while (!g_doorOpen) {
		// Open the door
		var door = getDoor();
		skapi.SelectAco(door);
		delayTime(1000);

		var key = skapi.AcoFromSz("Greeter's Key");
		delayTime(100);

		delayTime(50);
		key.UseOnAco(door);

		openDoor(door);	
		tries++;
		if (tries > 10) break;
	}
	if (!g_doorOpen) continue;

	route.FromFile(g_baseDir + g_routes[2]);
	if (route.Go(120)==1) continue;
	//if (g_restart == true) continue;

	var tries = 0;
	g_doorOpen = false;
	while (!g_doorOpen) {
		delayTime(500);
		var door = getDoor();
		delayTime(500);
		skapi.SelectAco(door);
		delayTime(100);

		var key = skapi.AcoFromSz("Greeter's Key");

		delayTime(50);
		key.UseOnAco(door);

		openDoor(door);	

		tries++;
		if (tries > 10) break;
	}
	if (!g_doorOpen) continue;

	var key = skapi.AcoFromSz("Quartermaster's Workshop Key");
	delayTime(500);
	if (key.cuseLeft == 1) {
		route.FromFile(g_baseDir + g_routes[4]);
		if (route.Go(160)==1) continue;
		//if (g_restart == true) continue;

		var blacksmith = skapi.AcoFromSz("Academy Blacksmith");
		skapi.SelectAco(blacksmith);
		delayTime(50);
		skapi.SelectAco(key);
		delayTime(50);
		skapi.Keys("u");	// Give item
		delayTime(6000);

		route.FromFile(g_baseDir + g_routes[5]);
		if (route.Go(120)==1) continue;
		//if (g_restart == true) continue;
	} else {
		route.FromFile(g_baseDir + g_routes[3]);
		if (route.Go(180)==1) continue;
		//if (g_restart == true) continue;
	}

	var tries = 0;
	g_doorOpen = false;
	while (!g_doorOpen) {
		var key = skapi.AcoFromSz("Quartermaster's Workshop Key");
		delayTime(500);

		var door = skapi.AcoFromSz("Academy Quartermaster's Workshop");
		skapi.SelectAco(door);

		delayTime(50);
		key.UseOnAco(door);

		openDoor(door);	
		if (tries > 10) break;
	}
	if (!g_doorOpen) continue;

	route.FromFile(g_baseDir + g_routes[6]);
	if (route.Go(180)==1) continue;
	//if (g_restart == true) continue;

	merch = skapi.AcoFromSz("Academy Quartermaster");
	skapi.SelectAco(merch);
	delayTime(50);
	skapi.Keys(cmidUseSelected);
	skapi.WaitEvent(20000,wemSpecific,evidOnApproachVendor);

	var mainpack = skapi.AcoFromIpackIitem(0,-1);

	skapi.AddHandler(evidOnAddToInventory,g_doorOpenHandler);

	for (var i=1; i<8; i++) {
		// Move to item list
		skapi.MouseMove(50,577);
		skapi.MouseButton(ibuttonLeft);
		delayTime(250);

		// Select cestus
		skapi.MouseMove(120,630);
		skapi.MouseButton(ibuttonLeft);
		delayTime(250);

		// Move to add to list
		skapi.MouseMove(686,640);
		delayTime(250);

		var pack = skapi.AcoFromIpackIitem(i,-1);
		var numToBuy = pack.citemMax-pack.citemContents;
		for (var j=0; j<numToBuy; j++) {
			// Add to list
			skapi.MouseButton(ibuttonLeft);
			delayTime(50);
		}

		// Move to buy list
		skapi.MouseMove(137,576);
		skapi.MouseButton(ibuttonLeft);
		delayTime(250);

		// Reset item bought counter to 0
		g_itemBought = 0;

		// Buy all
		skapi.MouseMove(686,640);
		skapi.MouseButton(ibuttonLeft);

		var iter = 0;
		while (g_itemBought < numToBuy &&
			   iter < 100)
		{
			delayTime(100);
			while (moveCestusToPack());
		}
	}

	skapi.RemoveHandler(evidOnAddToInventory,g_doorOpenHandler);

	delayTime(100);
	while (moveCestusToPack());

	var endTime = new Date();
	skapi.OutputLine("Run took: "+Math.round(((endTime-startTime)/1000)/60)+":"+(Math.round((endTime-startTime)/1000)%60));
	delayTime(50);
	totalMoneyMade += (skapi.cpyCash-curCash);
	skapi.OutputLine("Gained: "+(skapi.cpyCash-curCash)+" pyreals this run.  "+totalMoneyMade+" total.");
	}
	catch (e) {
		skapi.OutputLine(e.name + ": " + e.message);
		skapi.OutputLine(e.number + ": " + e.description);
	}
	}

//	skapi.RemoveHandler(evidOnLocChangeSelf,g_doorOpenHandler);
}
